<?PHP
/**
 * Zhen Mailer
 *
 * @package SMF Zhen Mailer v1.3
 * @PHP Mailer version 6.03
 * @license https://www.gnu.org/licenses/lgpl.html
 */
if (!defined('SMF'))
   die('Hacking attempt...');

function ZhenMailerSig()
{
	global $txt, $modSettings, $context, $sourcedir, $user_info;
	global $smcFunc;

	require_once($sourcedir . '/Subs-Post.php');
	loadLanguage('ZhenMailer');
	$modSettings['smtp_signature'] = !empty($modSettings['smtp_signature']) ? $modSettings['smtp_signature'] : '';

	if (!allowedTo('admin_forum'))
		fatal_error($txt['ZhenMailer_admin_error'], false);

	if (isset($_REQUEST['save']))
	{
		checkSession();

		foreach ($_POST['sig'] as $i => $signature)
		{
			if (trim($signature) == '')
				unset($_POST['sig'][$i]);
			else
			{
				$_POST['sig'][$i] = preg_replace('/[^a-zA-Z0-9\-\._]/', '' , $_POST['sig'][$i]);
				$_POST['sig'][$i] = $smcFunc['htmlspecialchars']($_POST['sig'][$i], ENT_QUOTES);
				preparsecode($_POST['sig'][$i]);
			}
		}

		updateSettings(array('smtp_signature' => implode("\n", $_POST['sig'])));

	}

	// Ready the current news.
	foreach (explode("\n", $modSettings['smtp_signature']) as $id => $line)
		$context['admin_current_smtp_sig'][$id] = array(
			'id' => $id,
			'unparsed' => un_preparsecode($line),
			'parsed' => preg_replace('~<([/]?)form[^>]*?[>]*>~i', '<em class="smalltext">&lt;$1form&gt;</em>', parse_bbc($line)),
		);

	loadTemplate('ManageZhenMailer');
	$context['sub_template'] = 'edit_smtp_sig';
	$context['page_title'] = $txt['ZhenMailer_sig'];
}

function ZhenMailerSettings($return_config = false)
{
	global $txt, $context, $settings, $boarddir, $sourcedir, $modSettings, $scripturl, $image_proxy_secret, $webmaster_email;

	loadLanguage('ZhenMailer');
	if (!allowedTo('admin_forum'))
		fatal_error($txt['ZhenMailer_admin_error'], false);

	require_once($sourcedir.'/Subs.php');
	require_once($sourcedir.'/ZhenMailerCron.php');
	$phpVer = !version_compare(phpversion(), '7.2.0', '<') ? true : false;
	$encryptionPass = !empty($modSettings['ZhenMail_password']) ? base64_decode($modSettings['ZhenMail_password']) : $image_proxy_secret;
	$gz = !empty($encryptionPass) && class_exists('ZipArchive') && $phpVer ? '' : '.gz';
	$checkCurl = in_array('curl', get_loaded_extensions());
	$checkZipArchive = empty($gz) ? $txt['ZhenMail_zipArchive_pos'] : (!$phpVer ? $txt['ZhenMail_phpVer_neg'] : $txt['ZhenMail_zipArchive_neg']);
	$checkPass = empty($encryptionPass) ? $txt['ZhenMail_encrypt_neg'] : ($encryptionPass == $image_proxy_secret ? $txt['ZhenMail_encrypt_default'] : $txt['ZhenMail_encrypt_pos']);
	list($emailDefAddr, $emailMsg, $_SESSION['ZhenMailerInvalidEmail'], $modSettings['ZhenMail_user_default']) = array('', '', (!empty($_SESSION['ZhenMailerInvalidEmail']) ? intval($_SESSION['ZhenMailerInvalidEmail']) : 0), (!empty($modSettings['ZhenMail_user_default']) ? intval($modSettings['ZhenMail_user_default']) : 0));
	if (!empty($modSettings['ZhenMail_user_default']) && !empty(ZhenMailerUserInfo($modSettings['ZhenMail_user_default'], 'email_address')))
	{
		$data = ZhenMailerUserInfo($modSettings['ZhenMail_user_default'], 'email_address');
		$emailDefAddr = !empty($data[$modSettings['ZhenMail_user_default']]['email_address']) ? $data[$modSettings['ZhenMail_user_default']]['email_address'] : '';
	}

	$emailsDefault = !empty($emailDefAddr) ? array($webmaster_email, $emailDefAddr) : array($webmaster_email);
	$checkEmailsDefault = sprintf($txt['ZhenMailer_default_emails'], implode(', ', $emailsDefault));
	$modSettings['ZhenMail_password'] = !empty($modSettings['ZhenMail_password']) ? $modSettings['ZhenMail_password'] : $image_proxy_secret;

	foreach (array('Pass', 'Dump', 'Purge', 'Cron') as $checkx)
		$_SESSION['ZhenMailer' . $checkx] = empty($_SESSION['ZhenMailer' . $checkx]) ? 0 : $_SESSION['ZhenMailer' . $checkx];

	switch($_SESSION['ZhenMailerInvalidEmail'])
	{
		case 1:
			$emailMsg = $txt['ZhenMailer_email_neg'];
			break;
		case 2:
			$emailMsg = $txt['ZhenMailer_email_null'];
			break;
		case 3:
			$emailMsg = $txt['ZhenMailer_email_pos'];
			break;
		case 4:
			$emailMsg = $txt['ZhenMailer_email_match'];
			break;
		default:
			$emailMsg = '';

	}

	$context['html_headers'] .= '
	<style type="text/css">
		#ZhenMailerMsg0 {
			opacity: 1;
			transition: 1s opacity;
			font-size:12px;
		}
		#ZhenMailerMsg1 {
			opacity: 1;
			transition: 1s opacity;
			font-size:12px;
		}
	</style>
	<script type="text/javascript">
		if(window.attachEvent) {
			window.attachEvent("onload", alertZhenMailerMsgs);
		}
		else {
			window.addEventListener("load", alertZhenMailerMsgs, false);
		}
		function alertZhenMailerMsgs() {
			document.getElementById("ZhenMailerMsg0").innerHTML = "' . ($_SESSION['ZhenMailerDump'] == 1 ? $txt['ZhenMailer_log_action_fail'] : ($_SESSION['ZhenMailerDump'] == 2 ? $txt['ZhenMailer_log_action'] : '')) . '";
			document.getElementById("ZhenMailerMsg1").innerHTML = "' . ($_SESSION['ZhenMailerPurge'] == 1 ? $txt['ZhenMail_purge_msg_neg'] : ($_SESSION['ZhenMailerPurge'] == 2 ? $txt['ZhenMail_purge_msg_pos'] : '')) . '";
			document.getElementById("ZhenMailerMsg2").innerHTML = "' . ($_SESSION['ZhenMailerPass'] == 1 ? $txt['ZhenMailer_psswd_neg'] : ($_SESSION['ZhenMailerPass'] == 2 ? $txt['ZhenMailer_psswd_pos'] : ($_SESSION['ZhenMailerPass'] == 3 ? $txt['ZhenMailer_psswd_def'] : ''))) . '";
			document.getElementById("ZhenMailerMsg3").innerHTML = "' . ($_SESSION['ZhenMailerCron'] == 1 ? $txt['ZhenMailer_cron_reset'] : '') . '";
			document.getElementById("ZhenMailerMsg4").innerHTML = "' . ($emailMsg) . '";
			window.setTimeout(alertZhenMailerFade, 4000);
			' . (empty($checkCurl) ? 'document.getElementById("ZhenMailer_cron_job").value = "0";' : '') . '
			' . (!empty($gz) ? 'document.getElementById("ZhenMail_enable_encrypt").value = "0";' : '') . '
			' . (!empty($gz) ? 'document.getElementById("ZhenMailer_attachments_encrypt").value = "0";' : '') . '
			' . (!class_exists('ZipArchive') ? 'document.getElementById("ZhenMailer_attachments").value = "0";' : '') . '
		}
		function alertZhenMailerFade() {
			document.getElementById("ZhenMailerMsg0").style.opacity = "0";
			document.getElementById("ZhenMailerMsg1").style.opacity = "0";
			document.getElementById("ZhenMailerMsg2").style.opacity = "0";
			document.getElementById("ZhenMailerMsg3").style.opacity = "0";
			document.getElementById("ZhenMailerMsg4").style.opacity = "0";
		}
	</script>';

	list($_SESSION['ZhenMailerPass'], $_SESSION['ZhenMailerDump'], $_SESSION['ZhenMailerPurge'], $_SESSION['ZhenMailerCron'], $_SESSION['ZhenMailerInvalidEmail']) = array(0, 0, 0, 0, 0);
	$config_vars = array(
			'myheading0' => '<span style="left;text-decoration: underline;">' . $txt['ZhenMailer_general_msg'] . '</span>',
			'myheading1' => '<span id="ZhenMailerMsg0" style="opacity: 1;" class="alert"></span>',
			'<span>&nbsp;</span>',
			'',
			'myheading14' => '<span style="text-decoration: underline;">' . $checkEmailsDefault .'</span>',
			'myheading15' => '<span id="ZhenMailerMsg4" style="opacity: 1;" class="alert"></span>',
			'<span>&nbsp;</span>',
			array('check', 'ZhenMail_send'),
			array('check', 'ZhenMail_fix_double'),
			array('check', 'ZhenMail_autopurge'),
			array('check', 'ZhenMail_purge'),
			array('int', 'ZhenMail_user_default'),
			'myheading2' => '<span id="ZhenMailerMsg1" style="opacity: 1;" class="alert"></span>',
			'',
			'myheading3' => '<span style="text-decoration: underline;">' . $checkZipArchive .'</span>',
			'<span>&nbsp;</span>',
			array('check', 'ZhenMail_enable_encrypt'),
			array('password', 'ZhenMail_password'),
			'myheading4' => '<span id="ZhenMailerMsg2" style="opacity: 1;" class="alert"></span>',
			'myheading5' => '<span style="text-decoration: underline;">' . $checkPass . '</span>',
			'myheading6' => '<span>&nbsp;</span>',
			'myheading7' => '<span>&nbsp;</span>',
			'',
			'myheading8' => '<span style="text-decoration: underline;">' . $txt['ZhenMailer_attach_msg'] . '</span>',
			'<span>&nbsp;</span>',
			array('check', 'ZhenMailer_attachments'),
			array('check', 'ZhenMailer_attachments_encrypt'),
			'myheading9' => '<span>&nbsp;</span>',
			'myheading10' => '<span>&nbsp;</span>',
			'',
			'myheading11' => '<span style="text-decoration: underline;">' . (!empty($checkCurl) ? $txt['ZhenMailer_cron_msg_pos'] : $txt['ZhenMailer_cron_msg_neg']) . '</span>',
			'<span>&nbsp;</span>',
			array('check', 'ZhenMailer_cron_job_ajax'),
			array('select', 'ZhenMailer_cron_job', array($txt['ZhenMailer_cron_never'], $txt['ZhenMailer_cron_day'], $txt['ZhenMailer_cron_wk'], $txt['ZhenMailer_cron_mth'])),
			'myheading12' => '<span id="ZhenMailerMsg3" style="opacity: 1;" class="alert"></span>',
			'',
			'myheading13' => '<span style="text-decoration: underline;">' . $txt['ZhenMailer_log_settings'] .'</span>',
			'<span>&nbsp;</span>',
			array('check', 'ZhenMailer_log_actions'),
			array('check', 'ZhenMailer_log_error'),

	);

	if ($return_config)
		return $config_vars;

	// Saving?
	if (isset($_GET['save']))
	{
		$_SESSION['ZhenMailerPass'] = $_POST['ZhenMail_password'][0] == '' && base64_decode($modSettings['ZhenMail_password']) !== $image_proxy_secret  && $image_proxy_secret !== '' ? 3 : 0;
		if (!empty($_POST['ZhenMail_password'][1]))
		{
			$_SESSION['ZhenMailerPass'] = $_POST['ZhenMail_password'][0] == $_POST['ZhenMail_password'][1] ? 2 : 1;
			$_POST['ZhenMail_password'][0] = base64_encode($_POST['ZhenMail_password'][0]);
			$_POST['ZhenMail_password'][1] = base64_encode($_POST['ZhenMail_password'][1]);

		}
		if (!empty($_POST['ZhenMail_send']))
		{
			$_POST['ZhenMail_send'] = 0;
			$_SESSION['ZhenMailerDump'] = ZhenMailerDump();

		}
		if (!empty($_POST['ZhenMail_purge']))
		{
			$_POST['ZhenMail_purge'] = 0;
			$rootPath = $boarddir . '/ZhenMailer';
			$fileArray = array('get_oauth_token.php', 'src', 'index.php', 'ZhenMailer.php', 'ZhenMailerClass.php', 'ZhenMailerDump.php', '.', '..');
			$paths = array_diff(scandir($rootPath), $fileArray);
			foreach ($paths as $path)
			{
				if (!is_dir($rootPath . '/' . $path))
					@unlink($rootPath . '/' . $path);
				else
				{
					$files = array_diff(scandir($rootPath . '/' . $path), array('.', '..'));
					foreach ($files as $file)
					{
						if (file_exists($rootPath . '/' . $path . '/' . $file))
							@unlink($rootPath . '/' . $path . '/' . $file);
					}

					@rmdir($rootPath . '/' . $path);
				}
			}
			$paths = array_diff(scandir($rootPath), $fileArray);
			$_SESSION['ZhenMailerPurge'] = empty($paths) ? 2 : 1;
		}
		if (!empty($_POST['ZhenMailer_cron_job']) && $_POST['ZhenMailer_cron_job'] !== (!empty($modSettings['ZhenMailer_cron_job']) ? $modSettings['ZhenMailer_cron_job'] : 0))
		{
			list($_SESSION['ZhenMailerCron'], $_SESSION['ZhenMailerRepeatTimer']) = array(1, 0);
			$blowfish = base64_encode(uniqidRealZhenMailer(30));
			updateSettings(array('ZhenMailer_cron_job_time' => time()));
			updateSettings(array('ZhenMailer_cron_job_blowfish' => $blowfish));
		}
		if (isset($_POST['ZhenMail_user_default']) && abs($_POST['ZhenMail_user_default']) !== abs($modSettings['ZhenMail_user_default']))
		{
			$num = abs($_POST['ZhenMail_user_default']);

			//$_POST['ZhenMail_user_default'] = abs($_POST['ZhenMail_user_default']);
			$data = ZhenMailerUserInfo($num, 'email_address');
			if (empty($num))
				$_SESSION['ZhenMailerInvalidEmail'] = 2;
			elseif (empty($data[$num]) || empty($data[$num]['email_address']))
			{
				$_POST['ZhenMail_user_default'] = 0;
				$_SESSION['ZhenMailerInvalidEmail'] = 1;
			}
			else
				$_SESSION['ZhenMailerInvalidEmail'] = 3;

			if (!empty($data[$num]['email_address']) && !empty($webmaster_email))
			{
				if (trim($data[$num]['email_address']) == trim($webmaster_email))
				{
					$_POST['ZhenMail_user_default'] = 0;
					$_SESSION['ZhenMailerInvalidEmail'] = 4;
				}
			}
		}

		checkSession();

		saveDBSettings($config_vars);
		redirectexit('action=admin;area=mailqueue;sa=zhenmailset');
	}

	$context['post_url'] = $scripturl . '?action=admin;area=mailqueue;save;sa=zhenmailset';
	$context['settings_title'] = $txt['ZhenMail_settings'];
	$context['page_title'] = $txt['ZhenMail_settings'];

	prepareDBSettingContext($config_vars);
}

function ZhenMailerFileCreation()
{
	global $txt, $context, $modSettings, $settings, $boarddir;

	loadLanguage('ZhenMailer');
	if (!allowedTo('admin_forum'))
		fatal_error($txt['ZhenMailer_admin_error'], false);

	$serverSoftware = strtolower(!empty($_SERVER['SERVER_SOFTWARE']) ? $_SERVER['SERVER_SOFTWARE'] : 'Unknown');
	$filepath = $boarddir . '/ZhenMailer';
	$path_array = explode('/', $filepath);
	$context['ZhenMailer_filepath'] = array_values(array_slice($path_array, -1))[0];
	$context['ZhenMailerServerInstruction'] = sprintf($txt['ZhenMailer_config_instruct'], (strpos($serverSoftware, 'apache') !== false ? $txt['ZhenMailer_configure_apache'] : $txt['ZhenMailer_configure_other']));
	$zhenVersion = '1.1';

	if (strpos($serverSoftware, 'apache') !== false)
		list($context['ZhenMailer_server'], $context['ZhenMailer_server_title'], $context['ZhenMailer_server_software']) = array(1, $txt['ZhenMailer_config_apache'], $serverSoftware);
	elseif (strpos($serverSoftware, 'microsoft-iis') !== false)
		list($context['ZhenMailer_server'], $context['ZhenMailer_server_title'], $context['ZhenMailer_server_software']) = array(2, $txt['ZhenMailer_config_iis'], $serverSoftware);
	else
		list($context['ZhenMailer_server'], $context['ZhenMailer_server_title'], $context['ZhenMailer_server_software']) = array(3, $txt['ZhenMailer_config_other'], $serverSoftware);

	$context['maintenance_finished'] = false;
	$context['html_headers'] .= '
	<style type="text/css">
		#zhenmail_fadeout {
			opacity: 1;
			transition: 1s opacity;
			text-align: center;
			font-size:18px;
		}
	</style>
	<script type="text/javascript">
		if(window.attachEvent) {
			window.attachEvent("onload", zhenmailFade);
		}
		else {
			window.addEventListener("load", zhenmailFade, false);
		}
		function zhenmailFade()
		{
			window.setTimeout(zhenmailFadeout, 4000);
		}
		function zhenmailFadeout()
		{
			document.getElementById("zhenmail_fadeout").style = "opacity: 0;";
		}
	</script>';

	if (isset($_REQUEST['select']) && isset($_REQUEST['create_config']) && $_REQUEST['create_config'] == 1)
	{
		// create Apache .htaccess file
		checkSession('request');
		ZhenMailerConfigDelete();
		if (!file_exists($filepath . '/.htaccess'))
		{
			$infofile ='#<!-- ' . $txt['ZhenMailer_config_apache'] . ' File Created by Zhen Mailer ' . $zhenVersion . ' -->';
			$infofile .= '
php_value memory_limit = 256M
php_value upload_max_filesize = 32M
post_max_size = 24M
php_value max_execution_time = 60
php value max_input_time = 90';

			$fp = fopen($filepath . '/.htaccess', 'w');
			fwrite($fp, $infofile, strlen($infofile));
			fclose ($fp);
		}

		$context['maintenance_finished'] = true;
		$context['maintenance_file'] = '.htaccess';
		$context['maintenance_task'] = $txt['ZhenMailer_config_file'][0];
	}
	elseif (isset($_REQUEST['select']) && isset($_REQUEST['create_config']) && $_REQUEST['create_config'] == 2)
	{
		// remove configuration file if opted
		checkSession('request');
		ZhenMailerConfigDelete();

		$context['maintenance_finished'] = true;
		$context['maintenance_file'] = '.htaccess';
		$context['maintenance_task'] = $txt['ZhenMailer_config_file'][1];
	}

	// Template
	list($_REQUEST['create_config'], $_REQUEST['select']) = array('', '');
	loadTemplate('ManageZhenMailer');
	$context['page_title'] = $txt['ZhenMail_file_config'];
	$context['sub_template'] = 'zhenmailer_php_config';
}

function ZhenMailerConfigDelete()
{
	// remove configuration file if opted
	global $boarddir;

	if (file_exists($boarddir . '/ZhenMailer/.htaccess'))
		unlink($boarddir . '/ZhenMailer/.htaccess');
}

function uniqidRealZhenMailer($length = 13)
{
    if (function_exists("random_bytes"))
        $bytes = random_bytes(ceil($length / 2));
    elseif (function_exists("openssl_random_pseudo_bytes"))
        $bytes = openssl_random_pseudo_bytes(ceil($length / 2));
    else
	{
		$characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$charactersLength = strlen($characters);
		$randomString = '';
		for ($i = 0; $i < $length; $i++)
			$randomString .= $characters[rand(0, $charactersLength - 1)];
		return substr($randomString, 0, 12);
	}

    return substr(bin2hex($bytes), 0, $length);
}

?>