<?PHP
/**
 * Zhen Mailer
 *
 * @package SMF Zhen Mailer v1.3
 * @PHP Mailer version 6.03
 * @license https://www.gnu.org/licenses/lgpl.html
 */
if (!defined('SMF'))
   die('Hacking attempt...');

function ZhenMailerCronJob()
{
	global $modSettings, $sourcedir, $scripturl, $context;

	if (empty($modSettings['ZhenMailer_cron_job']) || empty($modSettings['ZhenMailer_cron_job_time']) || !in_array('curl', get_loaded_extensions()) || empty($modSettings['ZhenMailer_cron_job_blowfish']))
		return false;

	$cron = false;
	$currentCron = $modSettings['ZhenMailer_cron_job'] == 1 ? '%a' : ($modSettings['ZhenMailer_cron_job'] == 2 ? '%d' : '%m');
	$lastRecord = date("Y-m-d", $modSettings['ZhenMailer_cron_job_time']);
	$currentDate = date("Y-m-d", time());
	$date1 = new DateTime($lastRecord);
	$date2 = new DateTime($currentDate);
	$diff = $date2->diff($date1)->format($currentCron);
	$setTime = $modSettings['ZhenMailer_cron_job_time'];
	$checkRepeat = !empty($_SESSION['ZhenMailerRepeatTimer']) ? $_SESSION['ZhenMailerRepeatTimer'] : time() - 300;

	switch ($currentCron)
	{
		case '%m':
		$cron = $diff > 0 ? true : false;
		break;
		case '%d':
		$cron = $diff > 7 ? true: false;
		break;
		default:
		$cron = $diff > 0 ? true : false;
	}

	if (!empty($cron) && time() - $setTime > 20 && time() - $checkRepeat < 360)
	{
		$_SESSION['ZhenMailerRepeatTimer'] = time() - 365;
		$blowfish = !empty($modSettings['ZhenMailer_cron_job_blowfish']) ? base64_decode($modSettings['ZhenMailer_cron_job_blowfish']) : '';

		// ajax request else direct
		if (!empty($modSettings['ZhenMailer_cron_job_ajax']))
		{
			$context['html_headers'] .= '
	<script type="text/javascript"><!-- // --><![CDATA[
		if(window.attachEvent) {
			window.attachEvent("onload", ZhenMailerScheduledEvent);
		}
		else {
			window.addEventListener("load", ZhenMailerScheduledEvent, false);
		}
		function ZhenMailerScheduledEvent() {
		var oXHR = new XMLHttpRequest();
		oXHR.open("POST", smf_scripturl + "?action=zhenmailerschedule;blowfishreq=' . rawurlencode($blowfish) . '");
		oXHR.send();
		}
	// ]]></script>';

			return true;
		}
		else
			return ZhenMailerCronJobInit($blowfish);
	}

	return false;
}

function ZhenMailerCronJobInit($blowfishReq = '')
{
	global $modSettings, $sourcedir, $context, $txt;

	if (empty($modSettings['ZhenMailer_cron_job']) || empty($modSettings['ZhenMailer_cron_job_time']) || !in_array('curl', get_loaded_extensions()) || empty($modSettings['ZhenMailer_cron_job_blowfish']))
	{
		if (!function_exists('template_main')) {
			function template_main() {
				// empty
			}
		}
		return false;
	}

	$blowfishRequest = !empty($_REQUEST['blowfishreq']) ? rawurldecode($_REQUEST['blowfishreq']) : '';
	$blowfishReq = !empty($blowfishReq) ? $blowfishReq : $blowfishRequest;
	$blowfish = base64_decode($modSettings['ZhenMailer_cron_job_blowfish']);
	$setTime = $modSettings['ZhenMailer_cron_job_time'];

	if (!empty($blowfishRequest))
	{
		$context['template_layers'] = array();
		$context['view'] = '';
		$context['message'] = '';
		loadTemplate('Xml');
		$context['sub_template'] = 'sendbody';
	}

	if ($blowfishReq !== $blowfish || empty($blowfishReq))
	{
		// don't log any error because people/bots may try to needlessly fill the log
		redirectexit();
	}
	elseif (empty($_SESSION['ZhenMailerScheduledBackup']) && time() - $setTime > 20)
	{
		require_once($sourcedir . '/Subs.php');
		// Allow 30 minutes to process else it will try again on failure
		$newBlowfish = base64_encode(uniqidNameZhenMailer(false, 50));
		updateSettings(array('ZhenMailer_cron_job_time' => $setTime + 1800));
		updateSettings(array('ZhenMailer_cron_job_blowfish' => $newBlowfish));

		$_SESSION['ZhenMailerScheduledBackup'] = ZhenMailerDump();
		$newBlowfish = base64_encode(uniqidNameZhenMailer(false, 50));
		updateSettings(array('ZhenMailer_cron_job_time' => time()));
		updateSettings(array('ZhenMailer_cron_job_blowfish' => $newBlowfish));

		return true;
	}

	return false;
}

function ZhenMailerEmailAttachment($backupDir, $filepaths, $msgID, $topicId)
{
	global $user_info, $modSettings, $scripturl, $image_proxy_secret, $boarddir, $txt;

	if (!class_exists('ZipArchive'))
		return false;

	loadLanguage('ZhenMailer');
	list($newFiles, $mail_result, $zipped) = array(array(), false, false);
	$image_proxy_secret = !empty($image_proxy_secret) ? $image_proxy_secret : '';
	$phpVer = !version_compare(phpversion(), '7.2.0', '<') ? true : false;
	$encryptionPass = !empty($modSettings['ZhenMail_password']) ? base64_decode($modSettings['ZhenMail_password']) : $image_proxy_secret;
	$encrypt = !empty($modSettings['ZhenMailer_attachments_encrypt']) && !empty($encryptionPass) && $phpVer ? true : false;
	$status = !empty($encrypt) ? $txt['ZhenMailer_encrypt_status_neg'] : $txt['ZhenMailer_encrypt_status_pos'];
	$decrypt = !empty($encrypt) ? '' : $txt['ZhenMailer_decrypt_7zip'];

	foreach ($filepaths as $filename)
	{
		if (file_exists($filename['filename']))
		{
			$fileext = strtolower(strrpos($filename['filename'], '.') !== false ? substr($filename['filename'], strrpos($filename['filename'], '.') + 1) : '');
			$needgZip = !in_array($fileext, array('zip', 'gz', 'rar', 'tar')) ? true : false;

			if ($needgZip || !empty($encrypt))
			{
				$newFile = preg_replace('/[^a-zA-Z0-9\-\._]/', '' , basename($filename['filename']));
				$zip = new ZipArchive(true);
				$res = $zip->open($backupDir . '/' . $newFile . '.zip', ZipArchive::CREATE);
				if ($res === TRUE)
				{
					if (!empty($encrypt))
					{
						$zip->addFile($filename['filename'], $newFile);
						$zip->setPassword($encryptionPass);
						$zip->setEncryptionName($newFile, ZipArchive::EM_AES_256);
						$zip->close();
					}
					else
					{
						$zip->addFile($filename['filename'], $newFile);
						$zip->close();
					}
					@unlink($filename['filename']);
					$zipped = 2;
					$newFile .= '.zip';
					$newFiles[] = $backupDir . '/' . $newFile;
				}
				else
				{
					$zipped = false;
					@unlink($filename['filename']);
					@rmdir($backupDir);
				}
			}
			else
			{
				$newFile = $filename['filename'];
				$zipped = 1;
				$newFiles[] = $backupDir . '/' . $newFile;
			}
		}
	}

	if (!empty($zipped))
		$mail_result = ZhenMailerSendAttachmentEmail($backupDir, $filepaths, $newFiles, $msgID, $topicId, $zipped);
	else
		log_error('[5]' . $txt['ZhenMailer_catch_error'] . ' ~ ' . $scripturl . '?msg=' . $msgID);

	return $mail_result;
}

function ZhenMailerSendAttachmentEmail($backupDir, $filepaths, $files, $msgID, $idTopic, $zipped)
{
	global $smcFunc, $db_name, $db_prefix, $boarddir, $db_user, $db_passwd, $db_server, $image_proxy_secret, $ZhenMailer, $webmaster_email, $mbname, $modSettings, $context, $txt, $user_info, $scripturl;

	loadLanguage('ZhenMailer');
	require_once($boarddir . '/ZhenMailer/ZhenMailerDump.php');
	require_once($boarddir . '/ZhenMailer/ZhenMailerClass.php');
	require_once($boarddir . '/ZhenMailer/ZhenMailer.php');

	list(
		$mail_result,
		$image_proxy_secret,
		$phpVer,
		$to,
		$subject,
		$charset,
		$msgUrl
	) = array(
		false,
		!empty($image_proxy_secret) ? $image_proxy_secret : '',
		!version_compare(phpversion(), '7.2.0', '<') ? true : false,
		$webmaster_email,
		'attachment-backup-' . time(),
		!empty($context['character_set']) ? $context['character_set'] : 'UTF-8',
		$scripturl . '?msg=' . strval($msgID),
	);

	$encryptionPass = !empty($modSettings['ZhenMail_password']) ? base64_decode($modSettings['ZhenMail_password']) : $image_proxy_secret;
	$encrypt = !empty($modSettings['ZhenMailer_attachments_encrypt']) && !empty($encryptionPass) && $phpVer ? true : false;
	$status = empty($encrypt) ? $txt['ZhenMailer_encrypt_status_neg'] : $txt['ZhenMailer_encrypt_status_pos'];
	$decrypt = empty($encrypt) ? '' : $txt['ZhenMailer_decrypt_7zip'];
	$topLink = sprintf($txt['ZhenMailer_attachment_postid'], $msgUrl);

	$message = sprintf($txt['ZhenMailer_auto_attmsg'], $mbname) . "\r\n" . sprintf($txt['ZhenMailer_auto_msg_date'], date("Y-m-d h:i:sa", time())) . "\r\n";
	if (count($files) == 1)
		$message .= sprintf($txt['ZhenMailer_auto_msg_filename'], basename($files[0])) . "\r\n";
	else
		$message .= sprintf($txt['ZhenMailer_auto_msg_filenames'], implode(', ', array_map('basename', $files))) . "\r\n";

	$message .= sprintf($txt['ZhenMailer_attachment_name'], $user_info['name'], $scripturl . '?action=profile;u=' . $user_info['id']) . "\r\n";

	foreach($filepaths as $data)
	{
		$attUrl = $scripturl . '?action=dlattach;topic=' . strval($idTopic) . ';attach=' . $data['id'];
		$attLink = sprintf($txt['ZhenMailer_attachment_attachid'], $attUrl);
		$message .= $attLink . "\r\n";
	}

	$message .= $topLink . "\r\n";
	$message .= sprintf($txt['ZhenMailer_encrypt_status'], $status, $decrypt) . "\r\n\r\n";
	$message .= $txt['ZhenMailer_attachment_security'] . "\r\n";
	$message .= ($zipped == 1 ? $txt['ZhenMailer_attachments_compneg'] : $txt['ZhenMailer_attachments_comppos']) . "\r\n";

	if (!empty($ZhenMailer))
		$mail_result = ZhenMailerSMF($to, $subject, $message, $message, false, $charset, true, $files);
	else
	{
		if (!empty($modSettings['ZhenMailer_log_error']))
			log_error($txt['ZhenMailer_catch_class_error']);
		$mail_result = false;
	}

	//if (!empty($mail_result) && !empty($modSettings['ZhenMailer_log_actions']))
		//logAction($txt['ZhenMailer_log_action'], array('member_affected' => 0), 'moderate');
	if (empty($mail_result) && !empty($modSettings['ZhenMailer_log_error']))
		log_error('[1] ' . $txt['ZhenMailer_dump_db_email_error']);

	if (!empty($modSettings['ZhenMail_autopurge']))
	{
		$checkfiles = array_diff(scandir($backupDir), array('.', '..'));
		foreach ($checkfiles as $file)
		{
			if (file_exists($backupDir . '/' . $file))
				@unlink($backupDir . '/' . $file);
		}
		@rmdir($backupDir);
	}

	return $mail_result;
}

function ZhenMailerDump()
{
	global $smcFunc, $db_name, $db_prefix, $boarddir, $db_user, $db_passwd, $db_server, $image_proxy_secret, $ZhenMailer, $webmaster_email, $mbname, $modSettings, $context, $txt;

	loadLanguage('ZhenMailer');
	require_once($boarddir . '/ZhenMailer/ZhenMailerDump.php');
	require_once($boarddir . '/ZhenMailer/ZhenMailerClass.php');
	require_once($boarddir . '/ZhenMailer/ZhenMailer.php');
	$image_proxy_secret = !empty($image_proxy_secret) ? $image_proxy_secret : '';
	$encryption = !empty($modSettings['ZhenMail_password']) ? base64_decode($modSettings['ZhenMail_password']) : $image_proxy_secret;
	$gz = !empty($encryption) && class_exists('ZipArchive') && !version_compare(phpversion(), '7.2.0', '<') && !empty($modSettings['ZhenMail_enable_encrypt']) ? '' : '.gz';
	$userDefault = !empty($modSettings['ZhenMail_user_default']) ? $modSettings['ZhenMail_user_default'] : 0;
	list(
		$tables,
		$allTables,
		$largerTables,
		$files,
		$newFiles,
		$num,
		$count,
		$size,
		$dbCount,
		$mail_to_array,
		$subject,
		$status,
		$decrypt,
		$charset,
		$backupDir,
		$filePrefix,
		$mail_result
	) = array(
		array(),
		array(),
		array(),
		array(),
		array(),
		0,
		0,
		0,
		0,
		$webmaster_email,
		'database-backup-' . time(),
		!empty($gz) ? $txt['ZhenMailer_encrypt_status_neg'] : $txt['ZhenMailer_encrypt_status_pos'],
		!empty($gz) ? '' : $txt['ZhenMailer_decrypt_7zip'],
		!empty($context['character_set']) ? $context['character_set'] : 'UTF-8',
		$boarddir . '/ZhenMailer/' . uniqidNameZhenMailer(false, 13),
		uniqidNameZhenMailer(false, 20),
		false
	);

	@mkdir($backupDir, 0775);
	@copy($boarddir . '/ZhenMailer/index.php', $backupDir . '/index.php');
	$result = $smcFunc['db_query']('',"
		SHOW TABLE STATUS FROM {raw:dbname}",
		array('dbname' => $db_name)
	);
	while ($row = $smcFunc['db_fetch_assoc']($result))
		$tables[] = array('name' => $row['Name'], 'size' => $row['Data_length']);

	$smcFunc['db_free_result']($result);

	// 20MB max for each (compressed) file or single file for any table over 20MB
	foreach ($tables as $table)
	{
		$size = $size + $table['size'];
		$mb = $size / 1024 / 1024;
		if (empty($allTables[$dbCount]))
			$allTables[$dbCount] = array();

		// compression rate of both gzip & zip should be approx. 36.5%
		if($mb*0.365 >= 20 && $size !== $table['size'])
		{
			$dbCount++;
			$size = $table['size'];
		}

		if (strpos($table['name'], $db_prefix . 'messages') !== false || strpos($table['name'], $db_prefix . 'members') !== false)
			$largerTables[$dbCount][] = $table['name'];
		else
			$allTables[$dbCount][] = $table['name'];
	}

	foreach ($allTables as $tables)
	{
		$num++;
		try
		{
			$large_dumper = Shuttle_Dumper::create(array(
				'host' => $db_server,
				'username' => $db_user,
				'password' => $db_passwd,
				'db_name' => $db_name,
				'include_tables' => $tables,
			));
			$files[] = $backupDir . '/' . $filePrefix . '-db_file' . $num . '.sql' . $gz;
			$large_dumper->dump($backupDir . '/' . $filePrefix . '-db_file' . $num . '.sql' . $gz);
		}
		catch(Shuttle_Exception $e)
		{
			$errMsg = '[2.0] ' . $e->getMessage();
			if (!empty($modSettings['ZhenMailer_log_error']))
				log_error('[2.0] ' . sprintf($txt['ZhenMailer_dump_db_error'], $errMsg));
		}
	}

	foreach ($largerTables as $tables)
	{
		$num++;
		try
		{
			$large_dumper = Shuttle_Dumper::create(array(
				'host' => $db_server,
				'username' => $db_user,
				'password' => $db_passwd,
				'db_name' => $db_name,
				'include_tables' => $tables,
			));
			$files[] = $backupDir . '/' . $filePrefix . '-db_file' . $num . '.sql' . $gz;
			$large_dumper->dump($backupDir . '/' . $filePrefix . '-db_file' . $num . '.sql' . $gz);
		}
		catch(Shuttle_Exception $e)
		{
			$errMsg = '[2.1] ' . $e->getMessage();
			if (!empty($modSettings['ZhenMailer_log_error']))
				log_error('[2.1] ' . sprintf($txt['ZhenMailer_dump_db_error'], $errMsg));
		}
	}

	if (!empty($files))
	{

		// if encryption is possible & enabled then use it
		if (empty($gz) && !empty($modSettings['ZhenMail_enable_encrypt']))
		{
			$all = true;
			foreach($files as $file)
			{
				$count++;
				$newFile = $filePrefix . '-db_file' . $count . '.sql';
				$zip = new ZipArchive(true);
				$res = $zip->open($backupDir . '/' . $newFile . '.zip', ZipArchive::CREATE);
				if ($res === TRUE)
				{
					$newFiles[] = $backupDir . '/' . $newFile . '.zip';
					$zip->addFile($file, $newFile);
					$zip->setPassword($encryption);
					$zip->setEncryptionName($newFile, ZipArchive::EM_AES_256);
					$zip->close();
					@unlink($file);
				}
				else
					$all = false;
			}
			$newFiles = !empty($newFiles) ? $newFiles : $files;
		}
		else
			$newFiles = $files;

		if (!empty($modSettings['ZhenMailer_OneFile']))
		{
			$zipNames = array($backupDir . '/' . $mbname . strval(time()) . '.zip');
			$zip2 = new ZipArchive(true);
			$res = $zip2->open($zipNames[0], ZipArchive::CREATE);
			foreach ($newFiles as $zipFile)
				$zip2->addFile($zipFile, basename($zipFile));

			$zip2->close();
		}
		else
			$zipNames = $newFiles;

		$message = sprintf($txt['ZhenMailer_auto_msg'], $mbname) . "\r\n" . sprintf($txt['ZhenMailer_auto_msg_date'], date("Y-m-d h:i:sa", time())) . "\r\n";
		$message .= sprintf($txt['ZhenMailer_encrypt_status'], $status, $decrypt) . "\r\n";

		if (!empty($ZhenMailer))
			$mail_result = ZhenMailerSMF($mail_to_array, $subject, $message, $message, false, $charset, true, $zipNames, $userDefault);
		else
		{
			if (!empty($modSettings['ZhenMailer_log_error']))
				log_error('[2.2] ' . $txt['ZhenMailer_catch_class_error']);
			$mail_result = false;
		}

		//if (!empty($mail_result) && !empty($modSettings['ZhenMailer_log_actions']))
			//logAction($txt['ZhenMailer_log_action'], array('member_affected' => 0), 'moderate');
		if (empty($mail_result) && !empty($modSettings['ZhenMailer_log_error']))
			log_error('[2.3] ' . $txt['ZhenMailer_dump_db_email_error']);

		if (!empty($modSettings['ZhenMail_autopurge']))
		{
			$files = array_diff(scandir($backupDir), array('.', '..'));
			foreach ($files as $file)
			{
				if (file_exists($backupDir . '/' . $file))
					@unlink($backupDir . '/' . $file);
			}
			@unlink($backupDir . '/index.php');
			@rmdir($backupDir);
		}
	}

	return empty($mail_result) ? 1 : 2;
}

function uniqidNameZhenMailer($basic = 0, $length = 13)
{
    if (empty($basic) && function_exists("random_bytes"))
        $bytes = random_bytes(ceil($length / 2));
    elseif (empty($basic) && function_exists("openssl_random_pseudo_bytes"))
        $bytes = openssl_random_pseudo_bytes(ceil($length / 2));
    else
	{
		$characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$charactersLength = strlen($characters);
		$randomString = '';
		for ($i = 0; $i < $length; $i++)
			$randomString .= $characters[rand(0, $charactersLength - 1)];
		return substr($randomString, 0, 12);
	}

    return substr(bin2hex($bytes), 0, $length);
}

?>