<?php
/**
 * PHP Mailer
 *
 * @package SMF Zhen Mailer v1.3
 * @PHP Mailer version 6.03
 * @license https://www.gnu.org/licenses/lgpl.html
 */

// Form for editing email signature
function template_edit_smtp_sig()
{
	global $context, $settings, $options, $scripturl, $txt;

	echo '
	<div id="admincenter">
		<form action="', $scripturl, '?action=admin;area=mailqueue;sa=editsig;save" method="post" accept-charset="', $context['character_set'], '" name="postmodify" id="postmodify">
			<table class="table_grid" width="100%">
				<thead>
					<tr class="catbg">
						<th class="first_th" style="width: 50%;">', $txt['admin_edit_ZhenMailer_sig'], '</th>
						<th style="text-align: left;width: 50%;">', $txt['ZhenMailer_preview'], '</th>
					</tr>
				</thead>
				<tbody>';

	foreach ($context['admin_current_smtp_sig'] as $admin_sig)
		echo '
					<tr class="windowbg2">
						<td align="center">

							<div style="margin-bottom: 2ex;"><textarea rows="3" cols="65" name="sig[]" style="' . ($context['browser']['is_ie8'] ? 'width: 635px; max-width: 85%; min-width: 85%' : 'width: 85%') . ';">', $admin_sig['unparsed'], '</textarea></div>
						</td>
						<td align="left" valign="top">
							<div style="overflow: auto; width: 100%; height: 10ex;">', $admin_sig['parsed'], '</div>
						</td>
					</tr>';
	// This provides an empty text box to add an email signature.
	echo '
					<tr id="moreNews" class="windowbg2" style="display: none;">
						<td align="center">
							<div id="moreNewsItems"></div>
						</td>
						<td align="center">
						</td>
						<td align="center">
						</td>
					</tr>
				</tbody>
			</table>
			<div class="floatleftpadding">
				<script type="text/javascript"><!-- // --><![CDATA[
					document.getElementById("moreNewsItems_link").style.display = "";
					function addNewsItem()
					{
						document.getElementById("moreNews").style.display = "";
						setOuterHTML(document.getElementById("moreNewsItems"), \'<div style="margin-bottom: 2ex;"><textarea rows="3" cols="65" name="sig[]" style="' . ($context['browser']['is_ie8'] ? 'width: 635px; max-width: 85%; min-width: 85%' : 'width: 85%') . ';"><\' + \'/textarea><\' + \'/div><div id="moreNewsItems"><\' + \'/div>\');
					}
				// ]]></script>
				<noscript>
					<div style="margin-bottom: 2ex;"><textarea rows="3" cols="65" style="' . ($context['browser']['is_ie8'] ? 'width: 635px; max-width: 85%; min-width: 85%' : 'width: 85%') . ';" name="sig[]"></textarea></div>
				</noscript>
			</div>
			<div class="floatrightpadding">
				<input type="submit" name="save_items" value="', $txt['ZhenMailer_save'], '" class="button_submit" />
			</div>
			<input type="hidden" name="', $context['session_var'], '" value="', $context['session_id'], '" />
		</form>
	</div>
	<br class="clear" />';
}

function template_zhenmailer_php_config()
{
	global $scripturl, $txt, $context, $settings;

	if ($context['maintenance_finished'])
		echo '
	<div id="zhenmail_fadeout" style="opacity: 1;">
		<div class="windowbg centertext" style="margin: 1ex; padding: 1ex 2ex; border: 1px dashed green; color: green;">
			<span>', sprintf($txt['ZhenMailer_config_file_task'], $context['maintenance_file'], $context['maintenance_task']), ' ~ ', $txt['ZhenMailer_config_done'], '</span>
		</div>
	</div>';


	echo '
	<form name="category" action="', $scripturl, '?action=admin;area=mailqueue;sa=phpconfig;" method="post">
		<div class="cat_bar">
			<h3 class="catbg">
				', $txt['ZhenMail_file_config'], ' - ', $txt['ZhenMail_php_config'], '
			</h3>
		</div>
		<div class="windowbg">
			<span class="topslice"><span></span></span>
				<div class="centertext" style="padding-top: 5px;padding-bottom: 15px;">', sprintf($txt['ZhenMailer_config_detected'], $context['ZhenMailer_server_software']), '</div>
				<div style="padding-bottom: 5px;padding-left: 1em;">', sprintf($txt['ZhenMailer_config_config'], $context['ZhenMailer_server_title']), '</div>
				<div style="padding-bottom: 25px;padding-left: 1em;">', $txt['ZhenMailer_config_remove'], '</div>
				<div style="padding: 0.5em;">
					<div style="padding-bottom: 3px;">
						<input style="vertical-align: middle;margin: 5px 5px;" class="icon" type="radio" name="create_config" value="1" /><span style="vertical-align: middle;padding: 2px 0px 2px 5px;">', $txt['ZhenMailer_config_create'][0], '</span>
					</div>
					<div style="padding-bottom: 3px;">
						<input style="vertical-align: middle;margin: 5px 5px;" class="icon" type="radio" name="create_config" value="2" /><span style="vertical-align: middle;padding: 2px 0px 2px 5px;">', sprintf($txt['ZhenMailer_config_create'][2], $context['ZhenMailer_filepath']), '</span>
					</div>
					<div style="padding-bottom: 3px;">
						<input style="vertical-align: middle;margin: 5px 5px;" class="icon" type="radio" name="disabled" disabled="disabled" disabled/><span style="vertical-align: middle;padding: 2px 0px 2px 5px;">', $txt['ZhenMailer_config_create'][1], '</span>
					</div>
					<div style="margin: 1ex;text-align: right;">
						<input class="button_submit" type="submit" name="select" value="', $txt['ZhenMailer_config_option'], '" />
					</div>
				</div>
				<div style="padding-top: 5px;"><span></span></div>
				<div style="padding: 1em;">',
					$context['ZhenMailerServerInstruction'], '
				</div>
			<span class="botslice"><span></span></span>
		</div>
		<div style="padding-bottom: 10px;"><span></span></div>
		<input type="hidden" name="', $context['session_var'], '" value="', $context['session_id'], '" />
	</form>';
}

?>